package zer01hd.zer10hdbot.listeners;

import java.util.Calendar;
import java.util.Random;

import net.dv8tion.jda.core.entities.Message;
import net.dv8tion.jda.core.entities.MessageChannel;
import net.dv8tion.jda.core.events.message.MessageReceivedEvent;
import net.dv8tion.jda.core.hooks.ListenerAdapter;
import zer01hd.zer10hdbot.Zer10HDBot;

public class MessageListener extends ListenerAdapter {
	Zer10HDBot z10b;
	Random rand = new Random();

	public MessageListener(Zer10HDBot z10b) {
		this.z10b = z10b;
	}
	
	@Override
	public void onMessageReceived(MessageReceivedEvent event) {
//		User user = event.getAuthor();
		Message message = event.getMessage();
		MessageChannel channel = event.getChannel();
		
		String msg = message.getContent();
		if (msg.equals(z10b.cmdPrefix)) {
			channel.sendMessage("Fool! Your doing it all wrong. You need an actual command after that.").queue();
		} else if (msg.equalsIgnoreCase("ping") || msg.substring(z10b.cmdPrefix.length()).equalsIgnoreCase("ping")) {
			channel.sendMessage("pong").queue();
			
		} else if (msg.startsWith(z10b.cmdPrefix)) {
			msg = msg.substring(z10b.cmdPrefix.length());
			
			if (msg.equalsIgnoreCase("ping")) {
				
				int roll = rand.nextInt(6) + 1;
				channel.sendMessage("Your roll: " + roll).queue(sentMessage -> {
					switch (roll) {
					case 2:
						channel.sendMessage("bad luck").queue();
						break;
					case 4:
						break;
					case 6:
						channel.sendMessage("nice roll!").queue();
						break;
					}
				});
			}
			
			
		} else if (msg.toLowerCase().contains("polyjet")) {
			int msgID = rand.nextInt(5);
			
			channel.sendMessage("keyword detected.").queue(sentMessage -> {
				String preNotedMsg = null;
				switch (msgID) {
				case 0:
					preNotedMsg = "shutup";
					break;
				case 1:
					preNotedMsg = "Be quiet! we dont speak of that anymore.";
					break;
				case 2:
					Calendar dueCal = Calendar.getInstance();
					dueCal.set(2017, 8, 17, 20, 55);
					Calendar current = Calendar.getInstance();
					
					float minutes = dueCal.getTimeInMillis() - current.getTimeInMillis();
					minutes /= 1000;
					minutes /= 60;
					
					preNotedMsg = "ya ya if you stop talking about *that* ill release it in:" + minutes + " minutes";
					break;
				case 3:
					preNotedMsg = "STOP IT.";
					break;
				case 4:
					preNotedMsg = "I dare you to speak of *it* again";
					break;
				}
				channel.sendMessage("Prenoted message from Zer01HD: \"" + preNotedMsg + "\"").queue();
			});
		}
		super.onMessageReceived(event);
	}
}
